builtin/pull: respect verbosity settings in submodules
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
1c244f6e 37files=
06b1abb5 38remote=
31ca3ac3 39nofetch=
32948425 40update=
15fc56a8 41prefix=
73b0898d 42custom_name=
275cd184 43depth=
72c5f883 44progress=
70c7ac22 45
be9d0a3a
HV
46die_if_unmatched ()
47{
48 if test "$1" = "#unmatched"
49 then
c4c02bf1 50 exit ${2:-1}
be9d0a3a
HV
51 fi
52}
53
88ce00c3
TK
54#
55# Print a submodule configuration setting
56#
57# $1 = submodule name
58# $2 = option name
59# $3 = default value
60#
61# Checks in the usual git-config places first (for overrides),
62# otherwise it falls back on .gitmodules. This allows you to
63# distribute project-wide defaults in .gitmodules, while still
64# customizing individual repositories if necessary. If the option is
65# not in .gitmodules either, print a default value.
66#
67get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
75 fi
76 printf '%s' "${value:-$default}"
77}
78
862ae6cd
RS
79isnumber()
80{
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
82}
83
14111fc4
JK
84# Sanitize the local git environment for use within a submodule. We
85# can't simply use clear_local_git_env since we want to preserve some
86# of the settings from GIT_CONFIG_PARAMETERS.
87sanitize_submodule_env()
88{
89044baa 89 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 90 clear_local_git_env
89044baa 91 GIT_CONFIG_PARAMETERS=$save_config
860cba61 92 export GIT_CONFIG_PARAMETERS
14111fc4
JK
93}
94
ecda0723
SV
95#
96# Add a new submodule to the working tree, .gitmodules and the index
97#
ec05df35 98# $@ = repo path
ecda0723
SV
99#
100# optional branch is stored in global branch variable
101#
23a485e3 102cmd_add()
ecda0723 103{
5c08dbbd 104 # parse $args after "submodule ... add".
091a6eb0 105 reference_path=
5c08dbbd
JH
106 while test $# -ne 0
107 do
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
113 ;;
d27b876b
JL
114 -f | --force)
115 force=$1
116 ;;
5c08dbbd 117 -q|--quiet)
2e6a30ef 118 GIT_QUIET=1
5c08dbbd 119 ;;
d92a3959
MT
120 --reference)
121 case "$2" in '') usage ;; esac
091a6eb0 122 reference_path=$2
d92a3959
MT
123 shift
124 ;;
125 --reference=*)
091a6eb0 126 reference_path="${1#--reference=}"
d92a3959 127 ;;
73b0898d
JL
128 --name)
129 case "$2" in '') usage ;; esac
130 custom_name=$2
131 shift
132 ;;
275cd184
FG
133 --depth)
134 case "$2" in '') usage ;; esac
135 depth="--depth=$2"
136 shift
137 ;;
138 --depth=*)
139 depth=$1
140 ;;
5c08dbbd
JH
141 --)
142 shift
143 break
144 ;;
145 -*)
146 usage
147 ;;
148 *)
149 break
150 ;;
151 esac
152 shift
153 done
154
091a6eb0
JK
155 if test -n "$reference_path"
156 then
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
159
160 reference="--reference=$reference_path"
161 fi
162
ecda0723 163 repo=$1
64394e3a 164 sm_path=$2
ecda0723 165
64394e3a 166 if test -z "$sm_path"; then
6a066230 167 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
169 fi
170
496eeeb1 171 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
172 usage
173 fi
174
091a6eb0
JK
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
176
ec05df35
ML
177 # assure repo is absolute or relative to parent
178 case "$repo" in
179 ./*|../*)
091a6eb0
JK
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
182
ec05df35 183 # dereference source url relative to parent's url
63e95beb 184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
185 ;;
186 *:*|/*)
187 # absolute url
188 realrepo=$repo
189 ;;
190 *)
497ee872 191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
192 ;;
193 esac
194
db75ada5
MG
195 # normalize path:
196 # multiple //; leading ./; /./; /../; trailing /
64394e3a 197 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
198 sed -e '
199 s|//*|/|g
200 s|^\(\./\)*||
8196e728 201 s|/\(\./\)*|/|g
db75ada5
MG
202 :start
203 s|\([^/]*\)/\.\./||
204 tstart
205 s|/*$||
206 ')
619acfc7
SB
207 if test -z "$force"
208 then
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211 else
212 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
214 fi
ecda0723 215
64394e3a 216 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 217 then
6ff875c5 218 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 219\$sm_path
6ff875c5 220Use -f if you really want to add it." >&2
d27b876b
JL
221 exit 1
222 fi
223
73b0898d
JL
224 if test -n "$custom_name"
225 then
226 sm_name="$custom_name"
227 else
228 sm_name="$sm_path"
229 fi
230
d4264ca3 231 # perhaps the path exists and is already a git repo, else clone it
64394e3a 232 if test -e "$sm_path"
d4264ca3 233 then
496eeeb1 234 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 235 then
64394e3a 236 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 237 else
64394e3a 238 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 239 fi
c2f93917 240
d4264ca3 241 else
4b7c286e
JL
242 if test -d ".git/modules/$sm_name"
243 then
244 if test -z "$force"
245 then
0d71dbfd 246 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 247 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
248 die "$(eval_gettextln "\
249If you want to reuse this local git directory instead of cloning again from
250 \$realrepo
251use the '--force' option. If the local git directory is not the correct repo
252or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 253 else
0d71dbfd 254 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
255 fi
256 fi
d10e3b42 257 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 258 (
14111fc4 259 sanitize_submodule_env
d851ffb9
JH
260 cd "$sm_path" &&
261 # ash fails to wordsplit ${branch:+-b "$branch"...}
262 case "$branch" in
263 '') git checkout -f -q ;;
264 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
265 esac
266 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 267 fi
73b0898d 268 git config submodule."$sm_name".url "$realrepo"
d4264ca3 269
64394e3a
RJ
270 git add $force "$sm_path" ||
271 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 272
73b0898d
JL
273 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
274 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
275 if test -n "$branch"
276 then
277 git config -f .gitmodules submodule."$sm_name".branch "$branch"
278 fi &&
31991b02 279 git add --force .gitmodules ||
64394e3a 280 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
281
282 # NEEDSWORK: In a multi-working-tree world, this needs to be
283 # set in the per-worktree config.
284 if git config --get submodule.active >/dev/null
285 then
286 # If the submodule being adding isn't already covered by the
287 # current configured pathspec, set the submodule's active flag
288 if ! git submodule--helper is-active "$sm_path"
289 then
290 git config submodule."$sm_name".active "true"
291 fi
292 else
293 git config submodule."$sm_name".active "true"
294 fi
ecda0723
SV
295}
296
19a31f9c
ML
297#
298# Execute an arbitrary command sequence in each checked out
299# submodule
300#
301# $@ = command to execute
302#
303cmd_foreach()
304{
1d5bec8b
JH
305 # parse $args after "submodule ... foreach".
306 while test $# -ne 0
307 do
308 case "$1" in
309 -q|--quiet)
310 GIT_QUIET=1
311 ;;
15fc56a8
JH
312 --recursive)
313 recursive=1
314 ;;
1d5bec8b
JH
315 -*)
316 usage
317 ;;
318 *)
319 break
320 ;;
321 esac
322 shift
323 done
324
f030c96d
ÆAB
325 toplevel=$(pwd)
326
4dca1aa6
BC
327 # dup stdin so that it can be restored when running the external
328 # command in the subshell (and a recursive call to this function)
329 exec 3<&0
330
b0f4b408
SB
331 {
332 git submodule--helper list --prefix "$wt_prefix" ||
c4c02bf1 333 echo "#unmatched" $?
b0f4b408 334 } |
cf9e55f4 335 while read -r mode sha1 stage sm_path
19a31f9c 336 do
c4c02bf1 337 die_if_unmatched "$mode" "$sha1"
64394e3a 338 if test -e "$sm_path"/.git
19a31f9c 339 then
44431df0 340 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
ea2fa104 341 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 342 name=$(git submodule--helper name "$sm_path")
15fc56a8 343 (
64394e3a 344 prefix="$prefix$sm_path/"
14111fc4 345 sanitize_submodule_env
64394e3a 346 cd "$sm_path" &&
44431df0 347 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
091a6eb0
JK
348 # we make $path available to scripts ...
349 path=$sm_path &&
1c4fb136
AK
350 if test $# -eq 1
351 then
352 eval "$1"
353 else
354 "$@"
355 fi &&
15fc56a8
JH
356 if test -n "$recursive"
357 then
358 cmd_foreach "--recursive" "$@"
359 fi
4dca1aa6 360 ) <&3 3<&- ||
ea2fa104 361 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
362 fi
363 done
364}
365
70c7ac22 366#
211b7f19 367# Register submodules in .git/config
70c7ac22
LH
368#
369# $@ = requested paths (default to all)
370#
23a485e3 371cmd_init()
70c7ac22 372{
5c08dbbd
JH
373 # parse $args after "submodule ... init".
374 while test $# -ne 0
375 do
376 case "$1" in
377 -q|--quiet)
2e6a30ef 378 GIT_QUIET=1
5c08dbbd
JH
379 ;;
380 --)
381 shift
382 break
383 ;;
384 -*)
385 usage
386 ;;
387 *)
388 break
389 ;;
390 esac
391 shift
392 done
393
6e7c14e6 394 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
395}
396
cf419828
JL
397#
398# Unregister submodules from .git/config and remove their work tree
399#
cf419828
JL
400cmd_deinit()
401{
402 # parse $args after "submodule ... deinit".
f6a52799 403 deinit_all=
cf419828
JL
404 while test $# -ne 0
405 do
406 case "$1" in
407 -f|--force)
408 force=$1
409 ;;
410 -q|--quiet)
411 GIT_QUIET=1
412 ;;
f6a52799
SB
413 --all)
414 deinit_all=t
415 ;;
cf419828
JL
416 --)
417 shift
418 break
419 ;;
420 -*)
421 usage
422 ;;
423 *)
424 break
425 ;;
426 esac
427 shift
428 done
429
f6a52799
SB
430 if test -n "$deinit_all" && test "$#" -ne 0
431 then
432 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
433 usage
434 fi
435 if test $# = 0 && test -z "$deinit_all"
cf419828 436 then
f6a52799 437 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
cf419828
JL
438 fi
439
b0f4b408
SB
440 {
441 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 442 echo "#unmatched" $?
b0f4b408 443 } |
cf9e55f4 444 while read -r mode sha1 stage sm_path
cf419828 445 do
c4c02bf1 446 die_if_unmatched "$mode" "$sha1"
0ea306ef 447 name=$(git submodule--helper name "$sm_path") || exit
cf419828 448
44431df0 449 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
091a6eb0 450
cf419828
JL
451 # Remove the submodule work tree (unless the user already did it)
452 if test -d "$sm_path"
453 then
454 # Protect submodules containing a .git directory
455 if test -d "$sm_path/.git"
456 then
0d71dbfd
VA
457 die "$(eval_gettext "\
458Submodule work tree '\$displaypath' contains a .git directory
459(use 'rm -rf' if you really want to remove it including all of its history)")"
cf419828
JL
460 fi
461
462 if test -z "$force"
463 then
7b294bf4 464 git rm -qn "$sm_path" ||
091a6eb0 465 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 466 fi
7b294bf4 467 rm -rf "$sm_path" &&
091a6eb0
JK
468 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
469 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
470 fi
471
091a6eb0 472 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
473
474 # Remove the .git/config entries (unless the user already did it)
475 if test -n "$(git config --get-regexp submodule."$name\.")"
476 then
477 # Remove the whole section so we have a clean state when
478 # the user later decides to init this submodule again
479 url=$(git config submodule."$name".url)
480 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 481 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
482 fi
483 done
484}
485
fb43e31f 486is_tip_reachable () (
01e1d544 487 sanitize_submodule_env &&
fb43e31f
SB
488 cd "$1" &&
489 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
490 test -z "$rev"
491)
492
493fetch_in_submodule () (
01e1d544 494 sanitize_submodule_env &&
fb43e31f
SB
495 cd "$1" &&
496 case "$2" in
497 '')
498 git fetch ;;
499 *)
6cbf454a
SB
500 shift
501 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
502 esac
503)
504
70c7ac22 505#
211b7f19 506# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
507#
508# $@ = requested paths (default to all)
509#
23a485e3 510cmd_update()
70c7ac22 511{
5c08dbbd
JH
512 # parse $args after "submodule ... update".
513 while test $# -ne 0
514 do
515 case "$1" in
516 -q|--quiet)
2e6a30ef 517 GIT_QUIET=1
5c08dbbd 518 ;;
72c5f883
JK
519 --progress)
520 progress="--progress"
521 ;;
be4d2c83 522 -i|--init)
d92a3959 523 init=1
be4d2c83 524 ;;
06b1abb5
TK
525 --remote)
526 remote=1
527 ;;
31ca3ac3 528 -N|--no-fetch)
31ca3ac3
FF
529 nofetch=1
530 ;;
9db31bdf
NMC
531 -f|--force)
532 force=$1
533 ;;
ca2cedba 534 -r|--rebase)
32948425 535 update="rebase"
ca2cedba 536 ;;
d92a3959
MT
537 --reference)
538 case "$2" in '') usage ;; esac
539 reference="--reference=$2"
98dbe63d 540 shift
d92a3959
MT
541 ;;
542 --reference=*)
543 reference="$1"
d92a3959 544 ;;
42b49178 545 -m|--merge)
42b49178
JH
546 update="merge"
547 ;;
b13fd5c1 548 --recursive)
b13fd5c1
JH
549 recursive=1
550 ;;
efc5fb6a
JH
551 --checkout)
552 update="checkout"
553 ;;
abed000a
SB
554 --recommend-shallow)
555 recommend_shallow="--recommend-shallow"
556 ;;
557 --no-recommend-shallow)
558 recommend_shallow="--no-recommend-shallow"
559 ;;
275cd184
FG
560 --depth)
561 case "$2" in '') usage ;; esac
562 depth="--depth=$2"
563 shift
564 ;;
565 --depth=*)
566 depth=$1
567 ;;
2335b870
SB
568 -j|--jobs)
569 case "$2" in '') usage ;; esac
570 jobs="--jobs=$2"
571 shift
572 ;;
573 --jobs=*)
574 jobs=$1
575 ;;
5c08dbbd
JH
576 --)
577 shift
578 break
579 ;;
580 -*)
581 usage
582 ;;
583 *)
584 break
585 ;;
586 esac
98dbe63d 587 shift
5c08dbbd
JH
588 done
589
d92a3959
MT
590 if test -n "$init"
591 then
592 cmd_init "--" "$@" || return
593 fi
594
48308681
SB
595 {
596 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
72c5f883 597 ${progress:+"$progress"} \
48308681
SB
598 ${wt_prefix:+--prefix "$wt_prefix"} \
599 ${prefix:+--recursive-prefix "$prefix"} \
600 ${update:+--update "$update"} \
5f50f33e 601 ${reference:+"$reference"} \
48308681 602 ${depth:+--depth "$depth"} \
abed000a 603 ${recommend_shallow:+"$recommend_shallow"} \
2335b870 604 ${jobs:+$jobs} \
c4c02bf1 605 "$@" || echo "#unmatched" $?
48308681 606 } | {
15ffb7cd 607 err=
cf9e55f4 608 while read -r mode sha1 stage just_cloned sm_path
70c7ac22 609 do
c4c02bf1 610 die_if_unmatched "$mode" "$sha1"
48308681 611
0ea306ef 612 name=$(git submodule--helper name "$sm_path") || exit
5be60078 613 url=$(git config submodule."$name".url)
efc5fb6a
JH
614 if ! test -z "$update"
615 then
616 update_module=$update
617 else
618 update_module=$(git config submodule."$name".update)
a2aed08b
TK
619 if test -z "$update_module"
620 then
621 update_module="checkout"
622 fi
efc5fb6a
JH
623 fi
624
44431df0 625 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 626
48308681 627 if test $just_cloned -eq 1
d851ffb9 628 then
bf2d8246 629 subsha1=
e7b37caf
SB
630 case "$update_module" in
631 merge | rebase | none)
632 update_module=checkout ;;
633 esac
bf2d8246 634 else
14111fc4 635 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 636 git rev-parse --verify HEAD) ||
091a6eb0 637 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 638 fi
211b7f19 639
06b1abb5
TK
640 if test -n "$remote"
641 then
92bbe7cc 642 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
643 if test -z "$nofetch"
644 then
645 # Fetch remote before determining tracking $sha1
6cbf454a 646 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
647 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
648 fi
14111fc4
JK
649 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
650 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 651 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 652 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
653 fi
654
496eeeb1 655 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 656 then
9db31bdf
NMC
657 subforce=$force
658 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 659 if test -z "$subsha1" && test -z "$force"
b9b378a0 660 then
9db31bdf 661 subforce="-f"
b9b378a0 662 fi
31ca3ac3
FF
663
664 if test -z "$nofetch"
665 then
e5f522d6
JL
666 # Run fetch only if $sha1 isn't present or it
667 # is not reachable from a ref.
fb43e31f 668 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 669 fetch_in_submodule "$sm_path" $depth ||
091a6eb0 670 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
671
672 # Now we tried the usual fetch, but $sha1 may
673 # not be reachable from any of the refs
674 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 675 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 676 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
677 fi
678
877449c1 679 must_die_on_failure=
32948425 680 case "$update_module" in
a2aed08b
TK
681 checkout)
682 command="git checkout $subforce -q"
683 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
684 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
685 ;;
32948425
JH
686 rebase)
687 command="git rebase"
091a6eb0
JK
688 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
689 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 690 must_die_on_failure=yes
32948425 691 ;;
42b49178
JH
692 merge)
693 command="git merge"
091a6eb0
JK
694 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
695 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 696 must_die_on_failure=yes
42b49178 697 ;;
6cb5728c
CP
698 !*)
699 command="${update_module#!}"
b08238ac
SB
700 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
701 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
702 must_die_on_failure=yes
703 ;;
32948425 704 *)
a2aed08b 705 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 706 esac
70c7ac22 707
14111fc4 708 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 709 then
ff968f03 710 say "$say_msg"
877449c1
JH
711 elif test -n "$must_die_on_failure"
712 then
ff968f03 713 die_with_status 2 "$die_msg"
15ffb7cd 714 else
ff968f03 715 err="${err};$die_msg"
877449c1 716 continue
15ffb7cd 717 fi
70c7ac22 718 fi
b13fd5c1
JH
719
720 if test -n "$recursive"
721 then
75bf5e60 722 (
44431df0 723 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 724 wt_prefix=
14111fc4 725 sanitize_submodule_env
75bf5e60 726 cd "$sm_path" &&
36141282 727 eval cmd_update
75bf5e60 728 )
15ffb7cd
FG
729 res=$?
730 if test $res -gt 0
731 then
091a6eb0 732 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 733 if test $res -ne 2
15ffb7cd 734 then
ff968f03 735 err="${err};$die_msg"
15ffb7cd
FG
736 continue
737 else
ff968f03 738 die_with_status $res "$die_msg"
15ffb7cd
FG
739 fi
740 fi
b13fd5c1 741 fi
70c7ac22 742 done
15ffb7cd
FG
743
744 if test -n "$err"
745 then
746 OIFS=$IFS
747 IFS=';'
748 for e in $err
749 do
750 if test -n "$e"
751 then
752 echo >&2 "$e"
753 fi
754 done
755 IFS=$OIFS
756 exit 1
757 fi
758 }
70c7ac22
LH
759}
760
bffe71f4
EM
761set_name_rev () {
762 revname=$( (
14111fc4 763 sanitize_submodule_env
bffe71f4 764 cd "$1" && {
5be60078
JH
765 git describe "$2" 2>/dev/null ||
766 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
767 git describe --contains "$2" 2>/dev/null ||
768 git describe --all --always "$2"
bffe71f4
EM
769 }
770 ) )
771 test -z "$revname" || revname=" ($revname)"
772}
28f9af5d
PY
773#
774# Show commit summary for submodules in index or working tree
775#
776# If '--cached' is given, show summary between index and given commit,
777# or between working tree and given commit
778#
779# $@ = [commit (default 'HEAD'),] requested paths (default all)
780#
781cmd_summary() {
f2dc06a3 782 summary_limit=-1
d0f64dd4 783 for_status=
1c244f6e 784 diff_cmd=diff-index
f2dc06a3 785
28f9af5d
PY
786 # parse $args after "submodule ... summary".
787 while test $# -ne 0
788 do
789 case "$1" in
790 --cached)
791 cached="$1"
792 ;;
1c244f6e
JL
793 --files)
794 files="$1"
795 ;;
d0f64dd4
PY
796 --for-status)
797 for_status="$1"
798 ;;
f2dc06a3 799 -n|--summary-limit)
862ae6cd
RS
800 summary_limit="$2"
801 isnumber "$summary_limit" || usage
f2dc06a3
PY
802 shift
803 ;;
862ae6cd
RS
804 --summary-limit=*)
805 summary_limit="${1#--summary-limit=}"
806 isnumber "$summary_limit" || usage
807 ;;
28f9af5d
PY
808 --)
809 shift
810 break
811 ;;
812 -*)
813 usage
814 ;;
815 *)
816 break
817 ;;
818 esac
819 shift
820 done
bffe71f4 821
f2dc06a3
PY
822 test $summary_limit = 0 && return
823
3deea89c 824 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
825 then
826 head=$rev
caa9c3ca 827 test $# = 0 || shift
496eeeb1 828 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 829 then
14e940d7
JH
830 # before the first commit: compare with an empty tree
831 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 832 test -z "$1" || shift
28f9af5d 833 else
3deea89c 834 head="HEAD"
28f9af5d
PY
835 fi
836
1c244f6e
JL
837 if [ -n "$files" ]
838 then
839 test -n "$cached" &&
465d6a00 840 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
841 diff_cmd=diff-files
842 head=
843 fi
844
28f9af5d 845 cd_to_toplevel
091a6eb0 846 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 847 # Get modified modules cared by user
18076502 848 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 849 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 850 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
851 do
852 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
853 if test "$status" = D || test "$status" = T
854 then
6a066230 855 printf '%s\n' "$sm_path"
496eeeb1
EP
856 continue
857 fi
927b26f8 858 # Respect the ignore setting for --for-status.
859 if test -n "$for_status"
860 then
0ea306ef 861 name=$(git submodule--helper name "$sm_path")
927b26f8 862 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 863 test $status != A && test $ignore_config = all && continue
927b26f8 864 fi
28f9af5d 865 # Also show added or modified modules which are checked out
2be94509 866 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 867 printf '%s\n' "$sm_path"
28f9af5d
PY
868 done
869 )
1cb639e6 870
d0f64dd4
PY
871 test -z "$modules" && return
872
18076502 873 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 874 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 875 cut -c2- |
cf9e55f4 876 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
877 do
878 if test -z "$cached" &&
879 test $sha1_dst = 0000000000000000000000000000000000000000
880 then
881 case "$mod_dst" in
882 160000)
883 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
884 ;;
885 100644 | 100755 | 120000)
886 sha1_dst=$(git hash-object $name)
887 ;;
888 000000)
889 ;; # removed
890 *)
891 # unexpected type
6ff875c5 892 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
893 continue ;;
894 esac
895 fi
896 missing_src=
897 missing_dst=
898
899 test $mod_src = 160000 &&
30353a40 900 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
901 missing_src=t
902
903 test $mod_dst = 160000 &&
30353a40 904 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 905 missing_dst=t
bffe71f4 906
44431df0 907 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 908
1cb639e6
PY
909 total_commits=
910 case "$missing_src,$missing_dst" in
911 t,)
091a6eb0 912 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
913 ;;
914 ,t)
091a6eb0 915 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
916 ;;
917 t,t)
091a6eb0 918 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
919 ;;
920 *)
921 errmsg=
922 total_commits=$(
496eeeb1 923 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
924 then
925 range="$sha1_src...$sha1_dst"
926 elif test $mod_src = 160000
927 then
928 range=$sha1_src
929 else
930 range=$sha1_dst
931 fi
932 GIT_DIR="$name/.git" \
b0e621ad 933 git rev-list --first-parent $range -- | wc -l
1cb639e6 934 )
eed35595 935 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
936 ;;
937 esac
938
939 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
940 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
941 if test $status = T
942 then
b3e73449
ÆAB
943 blob="$(gettext "blob")"
944 submodule="$(gettext "submodule")"
1cb639e6
PY
945 if test $mod_dst = 160000
946 then
091a6eb0 947 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 948 else
091a6eb0 949 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
950 fi
951 else
091a6eb0 952 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
953 fi
954 if test -n "$errmsg"
955 then
956 # Don't give error msg for modification whose dst is not submodule
957 # i.e. deleted or changed to blob
958 test $mod_dst = 160000 && echo "$errmsg"
959 else
496eeeb1 960 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 961 then
f2dc06a3
PY
962 limit=
963 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 964 GIT_DIR="$name/.git" \
f2dc06a3 965 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
966 --first-parent $sha1_src...$sha1_dst
967 elif test $mod_dst = 160000
968 then
969 GIT_DIR="$name/.git" \
970 git log --pretty='format: > %s' -1 $sha1_dst
971 else
972 GIT_DIR="$name/.git" \
973 git log --pretty='format: < %s' -1 $sha1_src
974 fi
975 echo
976 fi
977 echo
3ba7407b 978 done
28f9af5d 979}
70c7ac22 980#
941987a5 981# List all submodules, prefixed with:
70c7ac22
LH
982# - submodule not initialized
983# + different revision checked out
984#
985# If --cached was specified the revision in the index will be printed
986# instead of the currently checked out revision.
987#
988# $@ = requested paths (default to all)
989#
23a485e3 990cmd_status()
70c7ac22 991{
5c08dbbd
JH
992 # parse $args after "submodule ... status".
993 while test $# -ne 0
994 do
995 case "$1" in
996 -q|--quiet)
2e6a30ef 997 GIT_QUIET=1
5c08dbbd
JH
998 ;;
999 --cached)
1000 cached=1
1001 ;;
64b19ffe
JH
1002 --recursive)
1003 recursive=1
1004 ;;
5c08dbbd
JH
1005 --)
1006 shift
1007 break
1008 ;;
1009 -*)
1010 usage
1011 ;;
1012 *)
1013 break
1014 ;;
1015 esac
1016 shift
1017 done
1018
b0f4b408
SB
1019 {
1020 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 1021 echo "#unmatched" $?
b0f4b408 1022 } |
cf9e55f4 1023 while read -r mode sha1 stage sm_path
70c7ac22 1024 do
c4c02bf1 1025 die_if_unmatched "$mode" "$sha1"
0ea306ef 1026 name=$(git submodule--helper name "$sm_path") || exit
44431df0 1027 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
313ee0d6
NMC
1028 if test "$stage" = U
1029 then
1030 say "U$sha1 $displaypath"
1031 continue
1032 fi
6dc9f01f 1033 if ! git submodule--helper is-active "$sm_path" ||
496eeeb1
EP
1034 {
1035 ! test -d "$sm_path"/.git &&
1036 ! test -f "$sm_path"/.git
1037 }
70c7ac22 1038 then
64b19ffe 1039 say "-$sha1 $displaypath"
70c7ac22
LH
1040 continue;
1041 fi
64394e3a 1042 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1043 then
b545cd15 1044 set_name_rev "$sm_path" "$sha1"
64b19ffe 1045 say " $sha1 $displaypath$revname"
70c7ac22
LH
1046 else
1047 if test -z "$cached"
1048 then
14111fc4 1049 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1050 fi
b545cd15 1051 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1052 say "+$sha1 $displaypath$revname"
1053 fi
1054
1055 if test -n "$recursive"
1056 then
1057 (
1058 prefix="$displaypath/"
14111fc4 1059 sanitize_submodule_env
10450cf7 1060 wt_prefix=
64394e3a 1061 cd "$sm_path" &&
e15bec0e 1062 eval cmd_status
64b19ffe 1063 ) ||
64394e3a 1064 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1065 fi
1066 done
1067}
2327f61e
DA
1068#
1069# Sync remote urls for submodules
1070# This makes the value for remote.$remote.url match the value
1071# specified in .gitmodules.
1072#
1073cmd_sync()
1074{
1075 while test $# -ne 0
1076 do
1077 case "$1" in
1078 -q|--quiet)
2e6a30ef 1079 GIT_QUIET=1
2327f61e
DA
1080 shift
1081 ;;
82f49f29
PH
1082 --recursive)
1083 recursive=1
1084 shift
1085 ;;
2327f61e
DA
1086 --)
1087 shift
1088 break
1089 ;;
1090 -*)
1091 usage
1092 ;;
1093 *)
1094 break
1095 ;;
1096 esac
1097 done
1098 cd_to_toplevel
b0f4b408
SB
1099 {
1100 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 1101 echo "#unmatched" $?
b0f4b408 1102 } |
cf9e55f4 1103 while read -r mode sha1 stage sm_path
2327f61e 1104 do
c4c02bf1 1105 die_if_unmatched "$mode" "$sha1"
e7849a96
BW
1106
1107 # skip inactive submodules
25b31f1b 1108 if ! git submodule--helper is-active "$sm_path"
e7849a96
BW
1109 then
1110 continue
1111 fi
1112
25b31f1b 1113 name=$(git submodule--helper name "$sm_path")
2327f61e 1114 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1115
1116 # Possibly a url relative to parent
1117 case "$url" in
1118 ./*|../*)
967b2c66
JS
1119 # rewrite foo/bar as ../.. to find path from
1120 # submodule work tree to superproject work tree
6a066230 1121 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1122 # guarantee a trailing /
1123 up_path=${up_path%/}/ &&
1124 # path from submodule work tree to submodule origin repo
63e95beb 1125 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
967b2c66 1126 # path from superproject work tree to submodule origin repo
63e95beb 1127 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
967b2c66
JS
1128 ;;
1129 *)
1130 sub_origin_url="$url"
1131 super_config_url="$url"
baede9f8
JH
1132 ;;
1133 esac
1134
e7849a96
BW
1135 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1136 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1137 git config submodule."$name".url "$super_config_url"
1138
1139 if test -e "$sm_path"/.git
2327f61e 1140 then
e7849a96
BW
1141 (
1142 sanitize_submodule_env
1143 cd "$sm_path"
1144 remote=$(get_default_remote)
1145 git config remote."$remote".url "$sub_origin_url"
ccee6086 1146
e7849a96 1147 if test -n "$recursive"
ccee6086 1148 then
e7849a96
BW
1149 prefix="$prefix$sm_path/"
1150 eval cmd_sync
ccee6086 1151 fi
e7849a96 1152 )
2327f61e
DA
1153 fi
1154 done
1155}
70c7ac22 1156
f6f85861
SB
1157cmd_absorbgitdirs()
1158{
1159 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1160}
1161
5c08dbbd
JH
1162# This loop parses the command line arguments to find the
1163# subcommand name to dispatch. Parsing of the subcommand specific
1164# options are primarily done by the subcommand implementations.
1165# Subcommand specific options such as --branch and --cached are
1166# parsed here as well, for backward compatibility.
1167
1168while test $# != 0 && test -z "$command"
70c7ac22
LH
1169do
1170 case "$1" in
f6f85861 1171 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 1172 command=$1
70c7ac22
LH
1173 ;;
1174 -q|--quiet)
2e6a30ef 1175 GIT_QUIET=1
70c7ac22 1176 ;;
ecda0723
SV
1177 -b|--branch)
1178 case "$2" in
1179 '')
1180 usage
1181 ;;
1182 esac
1183 branch="$2"; shift
1184 ;;
70c7ac22 1185 --cached)
28f9af5d 1186 cached="$1"
70c7ac22
LH
1187 ;;
1188 --)
1189 break
1190 ;;
1191 -*)
1192 usage
1193 ;;
1194 *)
1195 break
1196 ;;
1197 esac
1198 shift
1199done
1200
5c08dbbd 1201# No command word defaults to "status"
af9c9f97
RR
1202if test -z "$command"
1203then
1204 if test $# = 0
1205 then
1206 command=status
1207 else
1208 usage
1209 fi
1210fi
5c08dbbd
JH
1211
1212# "-b branch" is accepted only by "add"
1213if test -n "$branch" && test "$command" != add
1214then
ecda0723 1215 usage
5c08dbbd
JH
1216fi
1217
28f9af5d 1218# "--cached" is accepted only by "status" and "summary"
496eeeb1 1219if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1220then
70c7ac22 1221 usage
5c08dbbd
JH
1222fi
1223
1224"cmd_$command" "$@"